package cn.ibizlab.core.sample.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.core.sample.domain.IBIZTASKTEAM;
import cn.ibizlab.core.sample.filter.IBIZTASKTEAMSearchContext;
import cn.ibizlab.core.sample.service.IIBIZTASKTEAMService;

import cn.ibizlab.util.helper.CachedBeanCopier;
import cn.ibizlab.util.helper.DEFieldCacheMap;
import com.alibaba.fastjson.JSONObject;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.core.sample.mapper.IBIZTASKTEAMMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import org.springframework.util.StringUtils;

/**
 * 实体[任务团队] 服务对象接口实现
 */
@Slf4j
@Service("IBIZTASKTEAMServiceImpl")
public class IBIZTASKTEAMServiceImpl extends ServiceImpl<IBIZTASKTEAMMapper, IBIZTASKTEAM> implements IIBIZTASKTEAMService {

    @Autowired
    @Lazy
    protected cn.ibizlab.core.sample.service.IIBIZTASKService ibiztaskService;

    protected int batchSize = 500;

    @Override
    @Transactional
    public boolean create(IBIZTASKTEAM et) {
        if(!this.retBool(this.baseMapper.insert(et))) {
            return false;
        }
        CachedBeanCopier.copy(get(et.getIbiztaskteamid()), et);
        return true;
    }

    @Override
    @Transactional
    public void createBatch(List<IBIZTASKTEAM> list) {
        this.saveBatch(list, batchSize);
    }

    @Override
    @Transactional
    public boolean update(IBIZTASKTEAM et) {
        if(!update(et, (Wrapper) et.getUpdateWrapper(true).eq("ibiztaskteamid", et.getIbiztaskteamid()))) {
            return false;
        }
        CachedBeanCopier.copy(get(et.getIbiztaskteamid()), et);
        return true;
    }

    @Override
    @Transactional
    public void updateBatch(List<IBIZTASKTEAM> list) {
        updateBatchById(list, batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result = removeById(key);
        return result ;
    }

    @Override
    @Transactional
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    @Transactional
    public IBIZTASKTEAM get(String key) {
        IBIZTASKTEAM et = getById(key);
        if (et == null) {
            throw new BadRequestAlertException("数据不存在", this.getClass().getSimpleName(), key);
        }
        else {
        }
        return et;
    }

    @Override
    public IBIZTASKTEAM getDraft(IBIZTASKTEAM et) {
        return et;
    }

    @Override
    public boolean checkKey(IBIZTASKTEAM et) {
        return (!ObjectUtils.isEmpty(et.getIbiztaskteamid())) && (!Objects.isNull(this.getById(et.getIbiztaskteamid())));
    }
    @Override
    @Transactional
    public boolean save(IBIZTASKTEAM et) {
        if(!saveOrUpdate(et)) {
            return false;
        }
        return true;
    }

    @Override
    @Transactional
    public boolean saveOrUpdate(IBIZTASKTEAM et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? getProxyService().update(et) : getProxyService().create(et);
        }
    }

    @Override
    @Transactional
    public boolean saveBatch(Collection<IBIZTASKTEAM> list) {
        List<IBIZTASKTEAM> create = new ArrayList<>();
        List<IBIZTASKTEAM> update = new ArrayList<>();
        for (IBIZTASKTEAM et : list) {
            if (ObjectUtils.isEmpty(et.getIbiztaskteamid()) || ObjectUtils.isEmpty(getById(et.getIbiztaskteamid()))) {
                create.add(et);
            } else {
                update.add(et);
            }
        }
        if (create.size() > 0) {
            getProxyService().createBatch(create);
        }
        if (update.size() > 0) {
            getProxyService().updateBatch(update);
        }
        return true;
    }

    @Override
    @Transactional
    public void saveBatch(List<IBIZTASKTEAM> list) {
        List<IBIZTASKTEAM> create = new ArrayList<>();
        List<IBIZTASKTEAM> update = new ArrayList<>();
        for (IBIZTASKTEAM et : list) {
            if (ObjectUtils.isEmpty(et.getIbiztaskteamid()) || ObjectUtils.isEmpty(getById(et.getIbiztaskteamid()))) {
                create.add(et);
            } else {
                update.add(et);
            }
        }
        if (create.size() > 0) {
            getProxyService().createBatch(create);
        }
        if (update.size() > 0) {
            getProxyService().updateBatch(update);
        }
    }


	@Override
    public List<IBIZTASKTEAM> selectByRoot(String ibiztaskid) {
        return baseMapper.selectByRoot(ibiztaskid);
    }
    @Override
    public void removeByRoot(String ibiztaskid) {
        this.remove(new QueryWrapper<IBIZTASKTEAM>().eq("root",ibiztaskid));
    }

    public IIBIZTASKTEAMService getProxyService() {
        return cn.ibizlab.util.security.SpringContextHolder.getBean(this.getClass());
    }
	@Override
    public void saveByRoot(String ibiztaskid,List<IBIZTASKTEAM> list) {
        if(list==null)
            return;
        Set<String> delIds=new HashSet<String>();
        List<IBIZTASKTEAM> _update=new ArrayList<IBIZTASKTEAM>();
        List<IBIZTASKTEAM> _create=new ArrayList<IBIZTASKTEAM>();
        for(IBIZTASKTEAM before:selectByRoot(ibiztaskid)){
            delIds.add(before.getIbiztaskteamid());
        }
        for(IBIZTASKTEAM sub:list) {
            sub.setRoot(ibiztaskid);
            if(ObjectUtils.isEmpty(sub.getIbiztaskteamid()))
                sub.setIbiztaskteamid((String)sub.getDefaultKey(true));
            if(delIds.contains(sub.getIbiztaskteamid())) {
                delIds.remove(sub.getIbiztaskteamid());
                _update.add(sub);
            }
            else
                _create.add(sub);
        }
        if(_update.size()>0)
            getProxyService().updateBatch(_update);
        if(_create.size()>0)
            getProxyService().createBatch(_create);
        if(delIds.size()>0)
            getProxyService().removeBatch(delIds);
	}


    /**
     * 查询集合 数据集
     */
    @Override
    public Page<IBIZTASKTEAM> searchDefault(IBIZTASKTEAMSearchContext context) {
            com.baomidou.mybatisplus.extension.plugins.pagination.Page<IBIZTASKTEAM> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
            return new PageImpl<IBIZTASKTEAM>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }







    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

    @Override
    public List<IBIZTASKTEAM> getIbiztaskteamByIds(List<String> ids) {
         return this.listByIds(ids);
    }

    @Override
    public List<IBIZTASKTEAM> getIbiztaskteamByEntities(List<IBIZTASKTEAM> entities) {
        List ids =new ArrayList();
        for(IBIZTASKTEAM entity : entities){
            Serializable id=entity.getIbiztaskteamid();
            if(!ObjectUtils.isEmpty(id)){
                ids.add(id);
            }
        }
        if(ids.size()>0) {
            return this.listByIds(ids);
        }
        else {
            return entities;
        }
    }




}



